//     www.cbr.ru    .
// Ver. 1.00 (20.09.2002)
// Copyright (c) 2002 by Andrew A. Fedorov
//    : http://www.bizkit.ru/rus/
// E-mail: fedorov@warlib.ru
//      :
// CurrencyExchange http://www.bizkit.ru/rus/
// Indy component http://www.nevrona.com/Indy/download90.html
// Cool Tray Icon http://www3.brinkster.com/troels/delphi.asp

unit curexchintodbcode;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, ComCtrls, Db, ADODB,inifiles, CurrencyExchange,
  CoolTrayIcon, ImgList, IdMessage,
  IdMessageClient, IdSMTP,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    MenuStart: TMenuItem;
    Timer: TTimer;
    Panel1: TPanel;
    Label1: TLabel;
    Interval: TEdit;
    SB: TStatusBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    server: TEdit;
    login: TEdit;
    pwd: TEdit;
    dbase: TEdit;
    Connection: TADOConnection;
    UpdateCurrExch: TADOQuery;
    Autostart: TCheckBox;
    Table: TEdit;
    Label6: TLabel;
    CurExch: TCurrencyExchange;
    Test1: TMenuItem;
    StartHidden: TCheckBox;
    N1: TMenuItem;
    ToTray1: TMenuItem;
    CoolTray: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    PopupStart: TMenuItem;
    N2: TMenuItem;
    Exit2: TMenuItem;
    Show1: TMenuItem;
    SMTP: TIdSMTP;
    IdMsgSend: TIdMessage;
    Label11: TLabel;
    SMTPServer: TEdit;
    Label12: TLabel;
    SMTPPort: TEdit;
    lblAuthenticationType: TLabel;
    cboAuthType: TComboBox;
    edtAccount: TEdit;
    lbAccount: TLabel;
    edtPassword: TEdit;
    lbPassword: TLabel;
    Email: TEdit;
    Label7: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure MenuStartClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ToTray1Click(Sender: TObject);
    procedure CoolTrayStartup(Sender: TObject; var ShowMainForm: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure CurExchCreateMSXMLError(Sender: TObject);
    procedure CurExchDataLoadingError(Sender: TObject);
    procedure CurExchDownloadError(Sender: TObject);
    procedure Test1Click(Sender: TObject);
  private
    function AddRecord(Value:TCurrencyExchange):integer;
    function GetLastUpdate:TDate;
    procedure UpdateCurExch;
    procedure LoadOptions;
    procedure SaveOptions;
    procedure Start;
    procedure Stop;
    procedure SendEmail(msg,subj:string);
    function ConnectToDB:integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LastUpdate,InitDate:TDate;
  SmtpServerName: String;
  SmtpServerPort: Integer;
  SmtpServerUser: String;
  SmtpServerPassword: String;
  SmtpAuthType: Integer;
  UserEmail: String;
  FromEmail: String;
  msg:string;

implementation

{$R *.DFM}

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

function TForm1.GetLastUpdate:TDate;
begin
  Result:=InitDate;
  try
    UpdateCurrExch.Close;
    UpdateCurrExch.SQL.Text:='select max(date) as LastUpdate from '+Table.Text;
    UpdateCurrExch.Open;
    Result:=UpdateCurrExch.FieldByName('LastUpdate').AsDateTime;
  except
    SendEmail('Current time: '+DateTimeToStr(now),'Couldn''t get LaAstUpdate information from database');
  end;
end;

function CommaToPoint(s:string):string;
var k:integer;
begin
  Result:='';
  for k:=1 to length(s) do
    if s[k]=',' then Result:=Result+'.' else Result:=Result+s[k];
end;

function TForm1.AddRecord(Value:TCurrencyExchange):integer;
var id,CurDate,USD,DEM,EUR:string;
    i:integer;
begin
  try
    Result:=1;
    id:='';
    CurDate:=FormatDateTime('yyyy-mm-dd',Value.BeginDate);
    for i:=0 to Value.Count-1 do begin
      if Value.GetCurrencyExchange[i].CharCode='USD' then USD:=CommaToPoint(Value.GetCurrencyExchange[i].Value) else
      if Value.GetCurrencyExchange[i].CharCode='EUR' then EUR:=CommaToPoint(Value.GetCurrencyExchange[i].Value) else
      if Value.GetCurrencyExchange[i].CharCode='DEM' then DEM:=CommaToPoint(Value.GetCurrencyExchange[i].Value);
    end;
    msg:=msg+CurDate+#$09+EUR+#$09+DEM+#$09+USD+#$0D#$0A;
    UpdateCurrExch.Close;
    UpdateCurrExch.SQL.Text:='sl_sp_tblcurrency_exchange_update '''+id+''','''+CurDate+''','''+EUR+''','''+DEM+''','''+USD+''',''''';
    UpdateCurrExch.Open;
  except
    Result:=0;
    SendEmail('Current time: '+DateTimeToStr(now),'MS SQL Server adding record error');
  end;
end;

procedure TForm1.UpdateCurExch;
const CurList:array[0..2] of string=
      //USD             EUR             DEM
      ('R01235',        'R01239',       'R01510');
var i:integer;
begin
  try
//    CurExch.BeginDate:=LastUpdate;
//    CurExch.EndDate:=Date;
    SendEmail('Current time: '+DateTimeToStr(now),'Try to get data from CBR.RU');
    for i:=0 to Length(CurList)-1 do CurExch.CurID.Add(CurList[i]);
    LastUpdate:=LastUpdate+1;
    if LastUpdate<InitDate then LastUpdate:=InitDate;
//    ShowMessage(DateToStr(LastUpdate));
    msg:='';
    while True do begin
      if LastUpdate>Date then break;
      //ShowMessage(DateToStr(LastUpdate));
      CurExch.BeginDate:=LastUpdate;
      CurExch.EndDate:=LastUpdate;
      CurExch.GetData;
      if CurExch.Count>0 then AddRecord(CurExch);
      LastUpdate:=LastUpdate+1;
    end;
    SendEmail('Date'+#$09#$09+'EUR'+#$09+'DEM'+#$09+'USD'+#$0D#$0A+msg,'Get data from CBR.RU');
  except
    SendEmail('Current time: '+DateTimeToStr(now),'Can''t get data from CBR.RU');
  end;
end;

function TForm1.ConnectToDB:integer;
const con='Provider=SQLOLEDB.1;Persist Security Info=True;';
var constr:string;
begin
  constr:=con+'User ID='+Login.Text+';Initial Catalog='+dbase.text+';Data Source='+Server.Text;
  Result:=1;
  try
    Connection.Connected:=False;
    Connection.ConnectionString:=constr;
    Connection.Connected:=True;
    UpdateCurrExch.Close;
    UpdateCurrExch.SQL.Text:='select * from '+Table.Text+' where id=0';
    UpdateCurrExch.Open;
//    LastUpdate:=GetLastUpdate;
    SB.Panels[0].Text:='Last update: '+DateToStr(LastUpdate);
  except
    Result:=0;
    SendEmail('Current time: '+DateTimeToStr(now),'MS SQL Server connection error');
  end;
end;

procedure TForm1.Start;
begin
  MenuStart.Caption:='&Stop';
  PopupStart.Caption:='&Stop';
  try
    Timer.Interval:=Round(StrToFloat(Interval.Text)*60*1000);
  except
    Timer.Interval:=600000;
  end;
  Timer.Enabled:=True;
//  Connection;
end;

procedure TForm1.Stop;
const con='Provider=SQLOLEDB.1;Persist Security Info=True;';
begin
  MenuStart.Caption:='&Start';
  PopupStart.Caption:='&Start';
  Timer.Enabled:=False;
  try
   UpdateCurrExch.Close;
   Connection.Connected:=False;
  except
    SendEmail('Current time: '+DateTimeToStr(now),'MS SQL Server disconnection error');
  end;
end;

procedure TForm1.MenuStartClick(Sender: TObject);
begin
  if Sender is TMenuItem then begin
    if (Sender as TMenuItem).Caption='&Start' then begin
      Start;
    end else begin
      Stop;
    end;
  end;
end;

procedure TForm1.SaveOptions;
var options:TIniFile;
    filename:string;
begin
  filename:=extractfilepath(paramstr(0))+'options.ini';
  options:=TIniFile.Create(filename);
  try
    with options do begin
      WriteString('OPTIONS','Interval',Interval.Text);
      WriteString('OPTIONS','Server',Server.Text);
      WriteString('OPTIONS','Login',Login.Text);
      WriteString('OPTIONS','Password',Pwd.Text);
      WriteString('OPTIONS','DBase',DBase.Text);
      WriteString('OPTIONS','Table',Table.Text);
      WriteDate('OPTIONS','LastUpdate',LastUpdate);
      WriteBool('OPTIONS','Autostart',Autostart.Checked);
      WriteBool('OPTIONS','StartHidden',StartHidden.Checked);
      WriteDate('OPTIONS','InitDate',InitDate);

      WriteString('Smtp', 'ServerName', SMTPServer.Text);
      SmtpServerName := SMTPServer.Text;

      WriteString('Smtp', 'ServerPort', SMTPPort.Text);
      SmtpServerPort := StrToIntDef(SMTPPort.Text, 110);

      WriteString('Smtp', 'ServerUser', edtAccount.Text);
      SmtpServerUser := edtAccount.Text;

      WriteString('Smtp', 'ServerPassword', edtPassword.Text);
      SmtpServerPassword := edtPassword.Text;

      WriteString('Email', 'FromEmail', FromEmail);

      WriteString('Email', 'PersonalEmail', Email.Text);
      UserEmail := Email.Text;

      WriteInteger('Smtp', 'SMTPAuthenticationType', cboAuthType.ItemIndex);
      SmtpAuthType := cboAuthType.ItemIndex;

    end;
  finally
    options.free;
  end;
end;

procedure TForm1.LoadOptions;
var options:TIniFile;
    filename:string;
begin
  filename:=extractfilepath(paramstr(0))+'options.ini';
  options:=TIniFile.Create(filename);
  try
    with options do begin
      Interval.Text:=ReadString('OPTIONS','Interval','60');
      Server.Text:=ReadString('OPTIONS','Server','');
      Login.Text:=ReadString('OPTIONS','Login','sa');
      Pwd.Text:=ReadString('OPTIONS','Password','');
      DBase.Text:=ReadString('OPTIONS','DBase','');
      Table.Text:=ReadString('OPTIONS','Table','');
//      LastUpdate:=ReadDate('OPTIONS','LastUpdate',LastUpdate);
      Autostart.Checked:=ReadBool('OPTIONS','Autostart',False);
      StartHidden.Checked:=ReadBool('OPTIONS','StartHidden',False);
      InitDate:=ReadDate('OPTIONS','InitDate',StrToDate('01.09.2002'));

      SmtpServerName := ReadString('Smtp', 'ServerName', 'smtp.server.com');
      SMTPServer.Text:=SmtpServerName;
      SmtpServerPort := StrToInt(ReadString('Smtp', 'ServerPort', '25'));
      SMTPPort.Text:=IntToStr(SmtpServerPort);
      SmtpServerUser := ReadString('Smtp', 'ServerUser', 'your_login');
      edtAccount.Text:=SmtpServerUser;
      SmtpServerPassword := ReadString('Smtp', 'ServerPassword', 'your_password');
      SmtpAuthType := ReadInteger('Smtp', 'SMTPAuthenticationType', 0);
      cboAuthType.ItemIndex:=SmtpAuthType;
      UserEmail := ReadString('Email', 'PersonalEmail', 'fedorov@warlib.ru');
      Email.Text:=UserEmail;
      FromEmail := ReadString('Email', 'FromEmail', 'fedorov@warlib.ru');
    end;
  finally
    options.free;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SaveOptions;
  Stop;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//  LoadOptions;
end;

procedure TForm1.TimerTimer(Sender: TObject);
var isConnected:boolean;
begin
  isConnected:=False;
  if Connection.Connected=False then
    if ConnectToDB=1 then isConnected:=True
  else isConnected:=True;
  if isConnected then begin
    LastUpdate:=GetLastUpdate;
    if LastUpdate<Date then begin  //     ,    
      UpdateCurExch;
      CoolTray.Hint:='  '+DateToStr(LastUpdate);
    end;
  end;
end;

procedure TForm1.ToTray1Click(Sender: TObject);
begin
  CoolTray.IconVisible:=True;
  CoolTray.HideMainForm;
end;

procedure TForm1.CoolTrayStartup(Sender: TObject;
  var ShowMainForm: Boolean);
begin
  LoadOptions;
  CurExch.SilentMode:=True;
  ShowMainForm := not StartHidden.Checked;
  CoolTray.MinimizeToTray:=True;
  if Autostart.Checked then Start;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  CoolTray.IconVisible:=false;
end;

procedure TForm1.Show1Click(Sender: TObject);
begin
  CoolTray.ShowMainForm;
end;

procedure TForm1.SendEmail(msg,subj:string);
begin
   with IdMsgSend do
      begin
         Body.Text:=msg;
         From.Text := FromEmail;
         ReplyTo.EMailAddresses := FromEmail;
         Recipients.EMailAddresses := Email.Text; { To: header }
         Subject := Subj; { Subject: header }
         Priority := mpHighest; { Message Priority }
         //CCList.EMailAddresses := edtCC.Text; {CC}
         //BccList.EMailAddresses := edtBCC.Text; {BBC}
      end;

  {authentication settings}
   case SmtpAuthType of
      0: SMTP.AuthenticationType := atNone;
      1: SMTP.AuthenticationType := atLogin; {Simple Login}
   end;
   SMTP.Username := SmtpServerUser;
   SMTP.Password := SmtpServerPassword;

   {General setup}
   SMTP.Host := SmtpServerName;
   SMTP.Port := SmtpServerPort;

   {now we send the message}
   try
     SMTP.Connect;
     try
        SMTP.Send(IdMsgSend);
     finally
        SMTP.Disconnect;
     end;
   except
     ShowMEssage('Can''t send message: '''+msg+''' to admin!');
   end;  
end;

procedure TForm1.CurExchCreateMSXMLError(Sender: TObject);
begin
  SendEmail('Can''t create MSXML object','MSXML object creation error');
end;

procedure TForm1.CurExchDataLoadingError(Sender: TObject);
begin
  SendEmail('Can''t load currency conversion table','Currency conversion error');
end;

procedure TForm1.CurExchDownloadError(Sender: TObject);
begin
  SendEmail('Can''t get currency excange data from ''Central Bank of Russia''','Currency table downloading error');
end;

procedure TForm1.Test1Click(Sender: TObject);
begin
  ShowMessage('      (www.cbr.ru)'#$0D#$0A+
             ' Currency Exchange Extractor ver. 1.00 (20.09.2002)'#$0D#$0A+
             'Copyright (c) 2002 by Andrew A. Fedorov'#$0D#$0A+
             '   : http://www.bizkit.ru/rus/'#$0D#$0A+
             'E-mail: fedorov@warlib.ru');
end;

end.
